"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _webpackAssetsManifest = _interopRequireDefault(require("webpack-assets-manifest"));

var _pluginData = _interopRequireDefault(require("./plugin-data"));

var _buildHeadersProgram = _interopRequireDefault(require("./build-headers-program"));

var _createRedirects = _interopRequireDefault(require("./create-redirects"));

var _constants = require("./constants");

// https://www.netlify.com/docs/headers-and-basic-auth/
let assetsManifest = {}; // Inject a webpack plugin to get the file manifests so we can translate all link headers

exports.onCreateWebpackConfig = ({
  actions,
  stage
}) => {
  if (stage !== _constants.BUILD_HTML_STAGE && stage !== _constants.BUILD_CSS_STAGE) {
    return;
  }

  actions.setWebpackConfig({
    plugins: [new _webpackAssetsManifest.default({
      assets: assetsManifest,
      // mutates object with entries
      merge: true
    })]
  });
};

exports.onPostBuild =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(function* ({
    store,
    pathPrefix
  }, userPluginOptions) {
    const pluginData = (0, _pluginData.default)(store, assetsManifest, pathPrefix);
    const pluginOptions = Object.assign({}, _constants.DEFAULT_OPTIONS, userPluginOptions);

    const _store$getState = store.getState(),
          redirects = _store$getState.redirects;

    let rewrites = [];

    if (pluginOptions.generateMatchPathRewrites) {
      const _store$getState2 = store.getState(),
            pages = _store$getState2.pages;

      rewrites = pages.filter(page => page.matchPath && page.matchPath !== page.path).map(page => {
        return {
          fromPath: page.matchPath,
          toPath: page.path
        };
      });
    }

    yield Promise.all([(0, _buildHeadersProgram.default)(pluginData, pluginOptions), (0, _createRedirects.default)(pluginData, redirects, rewrites)]);
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();